unit kmor;
(*****************************************************)

interface
(*****************************************************)
uses dos, crt;

(* casy trvania peep show bodky, ciary a medzery *)
const BODKACAS :real = 0.1;
      CIARACAS :real = 0.2;
      SYMBOLCAS:real = 0.05;
      ZNAKCAS  :real = 0.1;
      SLOVOCAS :real = 0.2;

      F:word = 1000; (* frekvencia peep show *)

      (* 26 znakov s max 4 symbolmi (bodka, ciara) *)
      MOR:array[1..26] of string[4] = (
      '.-',        (* A *)
      '-...',      (* B *)
      '-.-.',      (* C *)
      '-..',       (* D *)
      '.',         (* E *)
      '..-.',      (* F *)
      '--.',       (* G *)
      '....',      (* H *)
      '..',        (* I *)
      '.---',      (* J *)
      '-.-',       (* K *)
      '.-..',      (* L *)
      '--',        (* M *)
      '-.',        (* N *)
      '---',       (* O *)
      '.--.',      (* P *)
      '--.-',      (* Q *)
      '.-.',       (* R *)
      '...',       (* S *)
      '-',         (* T *)
      '..-',       (* U *)
      '...-',      (* V *)
      '.--',       (* W *)
      '-..-',      (* X *)
      '-.--',      (* Y *)
      '--..'       (* Z *)            );

      ODZNAK:string[1] = '|';
      ODSLOVO:string[2] = '|';

function startcas : real;
function stopcas(time:real) : real;
procedure vyckajcas(s : real);
procedure koduj(var fi:text; var fo:text; p:boolean);

implementation
(*****************************************************)
(* funkcia vrati cislo pre volanie funkcie stopcas *)
(* nevolat tesne pred polnocou *)
function startcas : real; 
var h, m, s, d : word;
begin
  gettime(h,m,s,d);
  startcas:=3600*h+60*m+s+d/100;
end;

(* funkcia vrati cas ubehnuty od volania startcas *)
(* nevolat tesne po polnoci *)
function stopcas(time:real) : real;
var h, m, s, d : word;
begin
  gettime(h,m,s,d);
  stopcas:=(3600*h+60*m+s+d/100)-time;
end;

(* procedura vycka zadany cas v s *)
procedure vyckajcas(s : real);
var aktual : real;
begin
  aktual:=startcas;
  repeat
  until stopcas(aktual)>s;
end;

procedure koduj(var fi:text; var fo:text; p:boolean);
var znak   : char; 
    symbol : string[4];
    i      : byte;
begin
  while not eof(fi) do begin 
    read(fi, znak); 
    if (znak>='a') and (znak<='z') then znak:=upcase(znak);
    if (znak>='A') and (znak<='Z') then begin
      write(fo, MOR[ord(znak)-ord('A')+1]);
      write(fo, ODZNAK);
      if p then begin
        symbol:=MOR[ord(znak)-ord('A')+1];
        for i:=1 to length(symbol) do begin
          if symbol[i]='.' then begin
            sound(F); vyckajcas(BODKACAS); nosound;
          end
          else begin
            sound(F); vyckajcas(CIARACAS); nosound;
          end;
          vyckajcas(SYMBOLCAS);
        end;
        vyckajcas(ZNAKCAS);
      end;
    end;
    if znak<=chr(32) then begin
      write(fo, ODSLOVO);
      if p then vyckajcas(SLOVOCAS); 
    end;
  end;
end;

begin
(*****************************************************)

end.